function cKick:SetupPopup()
	-- Popup Window
	local popup = CreateFrame("Frame", nil, UIParent)
	popup:Hide()
	popup:SetWidth(275)
	popup:SetHeight(125)
	popup:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
	})
	popup:SetBackdropBorderColor(.5, .5, .5)
	popup:SetBackdropColor(0,0,0)
	popup:ClearAllPoints()
	popup:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)
	
	local bg = popup:CreateTexture(nil, "BORDER")
	bg:SetWidth(popup:GetWidth())
	bg:SetHeight(popup:GetHeight())
	bg:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	bg:SetPoint("TOP", popup, "TOP", 0, -4)
	bg:SetBlendMode("ADD")
	bg:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, .5)
	popup.Bg = bg

	local header = popup:CreateFontString(nil, "OVERLAY")
	header:SetFont(select(1, GameFontNormal:GetFont()), 14)
	header:SetWidth(popup:GetWidth())
	header:SetText("header")
	header:SetTextColor(1, .8, 0)
	header:ClearAllPoints()
	header:SetPoint("TOP", popup, "TOP", 0, -9)
	popup.Header = header

	local info = popup:CreateFontString(nil, "OVERLAY")
	info:SetPoint("TOP", popup.Header, "BOTTOM", 0, -3)
	info:SetFont(select(1, GameFontNormal:GetFont()), 10)
	info:SetWidth(popup:GetWidth())
	info:SetText("info")
	info:SetTextColor(1, .8, 0)
	popup.Info = info

	-- Editboxes
	local nameBox = CreateFrame("EditBox", "cKick_Name_Box", popup, "InputBoxTemplate")
	nameBox:SetWidth(100)
	nameBox:SetHeight(19)
	nameBox:SetPoint("LEFT", popup, "CENTER", -20, -2)
	nameBox:SetMaxLetters(12)
	nameBox:SetTextInsets(0,0,3,3)
	nameBox:SetAutoFocus(false)
	nameBox:SetScript("OnEscapePressed", function() this:ClearFocus() end)
	nameBox:SetScript("OnEnterPressed", function() this:ClearFocus() end)

	nameBox.label = nameBox:CreateFontString(nil, "OVERLAY")
	nameBox.label:SetPoint("BOTTOM", nameBox, "TOP", -4, 2)
	nameBox.label:SetFont(select(1, GameFontNormal:GetFont()), 9)
	nameBox.label:SetWidth(nameBox:GetWidth())
	nameBox.label:SetText("Name")
	nameBox.label:SetTextColor(1, .8, 0)
	popup.NameBox = nameBox

	local idBox = CreateFrame("EditBox", "cKick_ID_Box", popup, "InputBoxTemplate")
	idBox:SetWidth(20)
	idBox:SetHeight(19)
	idBox:SetPoint("RIGHT", nameBox, "LEFT", -20, 0)
	idBox:SetMaxLetters(2)
	idBox:SetTextInsets(0,0,3,3)
	idBox:SetAutoFocus(false)
	idBox:IsNumeric(true)
	idBox:SetScript("OnEscapePressed", function() this:ClearFocus() end)
	idBox:SetScript("OnEnterPressed", function() this:ClearFocus() end)
	
	idBox.label = idBox:CreateFontString(nil, "OVERLAY")
	idBox.label:SetPoint("BOTTOM", idBox, "TOP", -4, 3)
	idBox.label:SetFont(select(1, GameFontNormal:GetFont()), 9)
	idBox.label:SetWidth(idBox:GetWidth())
	idBox.label:SetText("ID")
	idBox.label:SetTextColor(1, .8, 0)
	popup.IdBox = idBox
	
	local width, height = 100, 30
	
	-- Accept button
	local leftButton = CreateFrame("Button", nil, popup)
	leftButton:SetWidth(width)
	leftButton:SetHeight(height)
	leftButton:SetPoint("BOTTOMLEFT", popup, "BOTTOMLEFT", 25, 15)
	leftButton:SetScale(.9)
	leftButton:SetFrameLevel(leftButton:GetFrameLevel() + 1)
	leftButton:SetScript("OnClick", nil)
	
	local t = leftButton:CreateTexture()
	t:SetWidth(width)
	t:SetHeight(height)
	t:SetPoint("CENTER", leftButton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	leftButton:SetNormalTexture(t)

	t = leftButton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftButton)
	leftButton:SetPushedTexture(t)
	
	t = leftButton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftButton)
	t:SetBlendMode("ADD")
	leftButton:SetHighlightTexture(t)
	
	leftButton.Text = leftButton:CreateFontString(nil, "OVERLAY")
	leftButton.Text:SetFontObject(GameFontHighlight)
	leftButton.Text:SetText("Accept")
	leftButton.Text:SetAllPoints(leftButton)
	
	popup.LeftButton = leftButton
	
	-- Close button
	local rightButton = CreateFrame("Button", nil, popup)
	rightButton:SetWidth(width)
	rightButton:SetHeight(height)
	rightButton:SetPoint("BOTTOMRIGHT", popup, "BOTTOMRIGHT", -25, 15)
	rightButton:SetScale(.9)
	rightButton:SetFrameLevel(leftButton:GetFrameLevel() + 1)
	rightButton:SetScript("OnClick", function()
		popup:Hide()
		popup.IdBox:SetText("")
		popup.NameBox:SetText("")
	end)

	t = rightButton:CreateTexture()
	t:SetWidth(width)
	t:SetHeight(height)
	t:SetPoint("CENTER", rightButton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	rightButton:SetNormalTexture(t)

	t = rightButton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightButton)
	rightButton:SetPushedTexture(t)

	t = rightButton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightButton)
	t:SetBlendMode("ADD")
	rightButton:SetHighlightTexture(t)
	
	rightButton.Text = rightButton:CreateFontString(nil, "OVERLAY")
	rightButton.Text:SetFontObject(GameFontHighlight)
	rightButton.Text:SetText("Close")
	rightButton.Text:SetAllPoints(rightButton)
	
	popup.RightButton = rightButton
	
	local onClickAdd = function()
		self:AddKicker(popup.IdBox:GetNumber(), popup.NameBox:GetText())
	end
	
	local onClickRem = function()
		if ( #popup.NameBox:GetText() > 0 ) then
			self:RemoveKicker(popup.NameBox:GetText())
		else
			self:RemoveKicker(popup.IdBox:GetNumber())
		end
	end
	
	popup.ShowPopup = function(self, state)
		if ( state == "add" ) then
			self.Header:SetText("Add kicker")
			self.Info:SetText("ID and Name are required.")
			self.LeftButton:SetScript("OnClick", onClickAdd)
			self:Show()
		elseif ( state == "rem" ) then
			self.Header:SetText("Remove kicker")
			self.Info:SetText("ID or Name is required.")
			self.LeftButton:SetScript("OnClick", onClickRem)
			self:Show()
		end
	end
	
	self.Popup = popup
end
